package HT.fx;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.Scanner;

import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.ModalControllerInterface;
import fi.jyu.mit.ohj2.Mjonot;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.fxml.FXML;
import javafx.scene.Node;
import javafx.scene.control.Button;
import javafx.scene.control.TextField;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;

/**
 * @author joonatan, tuomas
 * @version 13.3.2024
 *
 */
public class OtteluIkkunaGUIController implements ModalControllerInterface<String> {
    
    @FXML private VBox Joukkue1VBox;

    @FXML private VBox Joukkue2VBox;

    @FXML private VBox MuokkaaVBox;

    @FXML private VBox TulosVBox;

    @FXML private void lisaatekstikentta(VBox boksi) {
        TextField newField = new TextField();
        boksi.getChildren().add(newField);
    }
    
    @FXML private void lisaaNappi(VBox boksi) {
        Button uusiNappi = new Button("Muokkaa");
        uusiNappi.setOnMouseClicked(new EventHandler<MouseEvent>() {
            @Override
            public void handle(MouseEvent arg0) {
                int i = boksi.getChildren().indexOf(uusiNappi);
                muokkaaOttelu(null, "kanat", i);
            }
        });
        boksi.getChildren().add(uusiNappi);
    }
    
    @FXML  void handleLisaaOttelu() {
        lisaakentat();
        LisaaOttelu(null, "kanat");
        SyotaTulos();
    }
    
    @FXML void handleHaeTiedot(MouseEvent event) {
        Lukija("/Users/joonatan/kurssit/ohj2/ht/src/Ottelutiedot");
    }

    @FXML void handleTallenna(MouseEvent event) {
        tallenna();
    }
    //=====================================
    
    public static String LisaaOttelu(Stage modalityStage, String oletus) {
        return ModalController.showModal(
                PadelLisaaOtteluGUIController.class.getResource("PadelLisaaOtteluGUIView.fxml"),
                "Lisää ottelu", modalityStage, oletus);
    }
    
    public static String muokkaaOttelu(Stage modalityStage, String oletus, int i) {
        return ModalController.showModal(
                PadelLisaaOtteluGUIController.class.getResource("PadelLisaaOtteluGUIView.fxml"),
                "Lisää ottelu", modalityStage, oletus);
    }
    
    public void tallenna() {
        try (PrintStream fo = new PrintStream(new FileOutputStream("/Users/joonatan/kurssit/ohj2/ht/src/Ottelutiedot", false)))  {
            int i = 0;
            while ( i<PadelMainGUIController.getKarkelo().noudaOttelut().size()) {
                
                fo.print(PadelMainGUIController.getKarkelo().noudaOttelu(i).getTiedot()+ "\n");
                i++;
                
            }
            //System.out.println("Heureka ! ");
        } catch(FileNotFoundException ex) {
            System.err.println("Tiedosto ei aukea: " + ex.getMessage());
        }
    }
    
    
    /**
     * @param tiedNimi Lukee tiedot tietystä tiedostosta
     */
    public void Lukija(String tiedNimi) {
        try (Scanner fi = new Scanner(new FileInputStream(new File(tiedNimi)))) { // Jotta UTF8/ISO-8859 toimii

            
            while ( fi.hasNext() ) {
                String s = fi.nextLine();
                if(s.length()>0) {
                    lisaakentat();
                    
                    StringBuffer sb = new StringBuffer(s);
                    int tunnus = Integer.parseInt(Mjonot.erota(sb,'|',false));
                    int os1 = Integer.parseInt(Mjonot.erota(sb,'|',false));
                    int os2 = Integer.parseInt(Mjonot.erota(sb,'|',false));
                    int os3 = Integer.parseInt(Mjonot.erota(sb,'|',false));
                    int os4 = Integer.parseInt(Mjonot.erota(sb,'|',false));
                    int voi1 = Integer.parseInt(Mjonot.erota(sb,'|',false));
                    int voi2 = Integer.parseInt(Mjonot.erota(sb,'|',false));
                    String paivamaara = Mjonot.erota(sb,'|',false);
                    DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-M-d");
                    LocalDate pvm = LocalDate.parse(paivamaara, formatter);
                    String lopputulos = Mjonot.erota(sb,'|',false);
                    
                    Ottelu uusi = new Ottelu(tunnus,pvm,os1,os2,os3,os4,voi1,voi2,lopputulos);
                    
                    
                    PadelMainGUIController.LisaaOttelu(uusi);
                    
                }
            }
        } catch (FileNotFoundException ex) {
            System.err.println("Tiedosto ei aukea! " + ex.getMessage());
            ex.printStackTrace();
            return;
        }
        SyotaTulos();

    }
    
    


    public void lisaakentat() {
        lisaatekstikentta(Joukkue1VBox);
        lisaatekstikentta(Joukkue2VBox);
        lisaaNappi(MuokkaaVBox);
        lisaatekstikentta(TulosVBox);
    }
    
    /**
     * Hakee kaikki luodun karkelon ottelut ja syöttää niiden tiedot
     * 
     * Tämän takia ei syötä tietoja oikein 
     */
    public void SyotaTulos() {
        int i = 0;
        
        Ottelu ottelu = PadelMainGUIController.getKarkelo().noudaOttelu(i);
        int[] numerot = ottelu.getPelaajaNrot();
        
        for (Node lapsi : Joukkue1VBox.getChildren()) {
            if (lapsi instanceof TextField) {
                TextField tf = (TextField) lapsi;
            
                tf.setText(haePelaaja(numerot[0]) + ", " + haePelaaja(numerot[1]));
                i++;
            }
        }
        
        for (Node lapsi : TulosVBox.getChildren()) {
            if (lapsi instanceof TextField) {
                TextField tf = (TextField) lapsi;
            
                tf.setText(ottelu.getLopputulos());
                
            }
        }
        
        for (Node lapsi : Joukkue2VBox.getChildren()) {
            if (lapsi instanceof TextField) {
                TextField tf = (TextField) lapsi;
            
                tf.setText(haePelaaja(numerot[2]) + ", " + haePelaaja(numerot[3]));
                
            }
        }

    }
    
    public String haePelaaja(int i) {
        return PadelMainGUIController.getKarkelo().annaPelaaja(i).getNimi();
    }
    

    @Override
    public String getResult() {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void handleShown() {
        // TODO Auto-generated method stub
        
    }

    @Override
    public void setDefault(String arg0) {
        // TODO Auto-generated method stub
        
    }

}
