package HT.fx;

import java.util.*;

/**
 * @author joonatan
 * @version 7.3.2024
 *
 */
public class Ottelut implements Iterable<Ottelu> {

    private final Collection<Ottelu> alkiot = new ArrayList<Ottelu>();
    private String tiedostonNimi = "";
    
    /**
     * 
     */
    public Ottelut() {
        //Ei tehdä vielä mitään.
    }
    
    /**
     * @param ott ottelu
     */
    public void lisaa(Ottelu ott) {
        alkiot.add(ott);
    }
    
    /**
     * Luo listan otteluista jotta saadaan palautettua yksi ottelu. 
     * Ominaisuus saattaa jäädä turhaksi myöhemmin
     * @param i monesko 
     * @return ottelu
     */
    public Ottelu haeOttelu(int i) {
        List<Ottelu> loydetyt = new ArrayList<Ottelu>();
        for(Ottelu ott : alkiot)
            loydetyt.add(ott);
        return loydetyt.get(i);
    }
    
    /**
     * Luo listan otteluista jotta saadaan palautettua yksi ottelu. 
     * Ominaisuus saattaa jäädä turhaksi myöhemmin
     * @return ottelut
     */
    public List<Ottelu> haeOttelut() {
        List<Ottelu> loydetyt = new ArrayList<Ottelu>();
        for(Ottelu ott : alkiot)
            loydetyt.add(ott);
        return loydetyt;
    }
    /**
     * Palauttaa otteluiden lukumäärän
     * @return otteluiden lukumäärä
     */
    public int getLkm() {
        return alkiot.size();
    }
    
    
    @Override
    public Iterator<Ottelu> iterator() {
        return alkiot.iterator();
    }
    
    /**
     * Haetaan pelaajien ottelut
     * @param tunnusnro pelaajan tunnusnro
     * @return Tietorakenne jossa viitteet löydettyihin otteluihin
     */
    public List<Ottelu> annaOttelut(int tunnusnro) {
        List<Ottelu> loydetyt = new ArrayList<Ottelu>();
        for(Ottelu ott : alkiot) {
            int i = 0;
            
            while(i<4){
                if (ott.getPelaajaNrot()[i] == tunnusnro) loydetyt.add(ott);
                i++;
            }
        }
        return loydetyt;
    }
    
/*
    public void lueTiedostosta(String tiedosto) {
        tiedostonNimi = tiedosto + "/nimet.dat";
        throw new SailoException("Ei osata vielä lukea tiedostoa " + tiedostonNimi);
        
    }

  */ 
}